﻿namespace UltraGridHorizontalNavigationButtons
{
    using Infragistics.Win.UltraWinGrid;
    using System;
    using System.Data;
    using System.Windows.Forms;

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.CreationFilter = new HideScrollbarsCreationFilter();

            this.ultraGrid1.DataSource = this.InitializeGridSource(100);
            this.ultraGrid1.DisplayLayout.Bands[0].CardView = true;
            
            this.previousButton.Click += new EventHandler(previousButton_Click);
            this.nextButton.Click += new EventHandler(nextButton_Click);
        }

        private void nextButton_Click(object sender, EventArgs e)
        {
            this.ultraGrid1.Rows.ScrollCardIntoView(this.GetNextHiddenRow(this.ultraGrid1));
        }

        private UltraGridRow GetNextHiddenRow(UltraGrid grid)
        {
            var firstVisibleRow = this.ultraGrid1.Rows.FirstVisibleCardRow;
            foreach (UltraGridRow row in grid.Rows)
            {
                if (!grid.Rows.IsCardVisible(row) && row.Index > firstVisibleRow.Index)
                {
                    return row;
                }
            }

            return grid.Rows[grid.Rows.Count - 1];
        }

        private void previousButton_Click(object sender, EventArgs e)
        {
            this.ultraGrid1.Rows.ScrollCardIntoView(this.GetPreviousHiddenRow(this.ultraGrid1));
        }

        private UltraGridRow GetPreviousHiddenRow(UltraGrid grid)
        {
            if (grid.Rows.FirstVisibleCardRow.Index == 0)
            {
                return grid.Rows.FirstVisibleCardRow;
            }

            return grid.Rows[grid.Rows.FirstVisibleCardRow.Index - 1];
        }

        private DataTable InitializeGridSource(int rows = 100)
        {
            DataTable newTable = new DataTable("Table1");

            newTable.Columns.Add("Hidden Text Column", typeof(string));
            newTable.Columns.Add("TextAndCheckEditor", typeof(bool));
            newTable.Columns.Add("Integer", typeof(int));

            for (int index = 0; index < rows; index++)
            {
                newTable.Rows.Add(new object[] { "text" + index, false, index });
            }

            return newTable;
        }
    }
}
